do
	local MyUnitIdTable = {
		'ch_bea01',
		'ch_def01',
		'ch_def02',
		'ch_et01',
		'ch_fas01',
		'ch_fas02',
		'ch_fas03',
		'ch_mul01',
		'ch_mul02',
		'ch_rng01',
		'ch_rng02',
		'ch_spl01',
		'ch_spl02',
		'ch_sta01',
		'ch_sta02',
		'ch_sta03',
		'ch_upg01',
		'ch_upg02',
		'ch_upg03',
		'ch_upg04',
		'ch_upg05',
		'ch_upg11',
		'ch_upg12',
		'ch_upg13',
		'ch_upg14',
		'ch_upg15',
	}
	local oldFileNameFn = GetUnitIconFileNames
   
	local function IsMyUnit(blueprint)
		for i, v in MyUnitIdTable do
			if v == blueprint.Display.IconName then
				return true
			end
		end
		return false
	end
   
	function GetUnitIconFileNames(blueprint)
		if IsMyUnit(blueprint) then
	        local iconName = "/mods/HiraganaV12/units/" .. blueprint.Display.IconName .. "/" .. blueprint.Display.IconName .. "_icon.dds"
	        local upIconName = "/mods/HiraganaV12/units/" .. blueprint.Display.IconName .. "/" .. blueprint.Display.IconName .. "_build_btn_up.dds"
	        local downIconName = "/mods/HiraganaV12/units/" .. blueprint.Display.IconName .. "/" .. blueprint.Display.IconName .. "_build_btn_down.dds"
	        local overIconName = "/mods/HiraganaV12/units/" .. blueprint.Display.IconName .. "/" .. blueprint.Display.IconName .. "_build_btn_over.dds"
	         
	        if DiskGetFileInfo(iconName) == false then
				iconName = '/textures/ui/common/icons/units/default_icon.dds'
	        end
	         
	        if DiskGetFileInfo(upIconName) == false then
				upIconName = iconName
	        end

	        if DiskGetFileInfo(downIconName) == false then
	            downIconName = iconName
	        end

	        if DiskGetFileInfo(overIconName) == false then
	            overIconName = iconName
	        end
	         
			return iconName, upIconName, downIconName, overIconName
		else
			return oldFileNameFn(blueprint)
		end
	end
end