local AReactonCannonAOEProjectile = import('/lua/aeonprojectiles.lua').AReactonCannonAOEProjectile
local utilities = import('/lua/utilities.lua')

ch_wpn_slow01 = Class(AReactonCannonAOEProjectile) {
    OnImpact = function(self, TargetType, TargetEntity)
		AReactonCannonAOEProjectile.OnImpact(self, TargetType, TargetEntity)
	
		local unit = self:GetLauncher()
		
		if TargetEntity then
			local slowLength = 7
			local slowSpeed = 0.5
			
			local SlowThread = ForkThread(function(self)
				if TargetEntity:IsDead() == false then
					if unit then
						-- Makes the shooter shoot at a different unit if possible
						if unit:IsDead() == false then
							local targets = {}
							targets = utilities.GetEnemyUnitsInSphere(unit, unit:GetPosition(), unit:GetWeapon(1):GetBlueprint().MaxRadius)
							if table.getn(targets) > 0 then
								local newTarget = targets[Random(1, table.getn(targets))]
								while (newTarget == TargetEntity) and (table.getn(targets) != 1) do
									newTarget = targets[Random(1, table.getn(targets))]
								end
								unit:GetWeapon(1):SetTargetEntity(newTarget)
							end
						end
					end
					
					if TargetEntity.slowCounter then
						TargetEntity.slowCounter = TargetEntity.slowCounter + 1
					else
						TargetEntity.slowCounter = 1
					end
					
					TargetEntity:SetSpeedMult(slowSpeed)
					local emitter = CreateAttachedEmitter(TargetEntity, 0, TargetEntity:GetArmy(), '/effects/emitters/aeon_shield_generator_t2_01_emit.bp'):ScaleEmitter(0.5)
					WaitSeconds(slowLength)
					
					if TargetEntity:IsDead() == false then
						emitter.Destroy(emitter)
						TargetEntity.slowCounter = TargetEntity.slowCounter - 1
						if TargetEntity.slowCounter == 0 then
							TargetEntity:SetSpeedMult(1)
						end
					end
				end
				KillThread(self)
			end)
		end
		self:Destroy()
    end,
}
TypeClass = ch_wpn_slow01