local TStructureUnit = import('/lua/terranunits.lua').TStructureUnit
local WeaponFile = import('/lua/sim/DefaultWeapons.lua')
local DefaultBeamWeapon = WeaponFile.DefaultBeamWeapon
local CollisionBeam = import('/lua/sim/CollisionBeam.lua').CollisionBeam
local EffectTemplate = import('/lua/EffectTemplates.lua')

SCCollisionBeam = Class(CollisionBeam) {
    FxImpactUnit = EffectTemplate.DefaultProjectileLandUnitImpact,
    FxImpactLand = {},#EffectTemplate.DefaultProjectileLandImpact,
    FxImpactWater = EffectTemplate.DefaultProjectileWaterImpact,
    FxImpactUnderWater = EffectTemplate.DefaultProjectileUnderWaterImpact,
    FxImpactAirUnit = EffectTemplate.DefaultProjectileAirUnitImpact,
    FxImpactProp = {},
    FxImpactShield = {},    
    FxImpactNone = {},
}

ch_bea01_Beam = Class(SCCollisionBeam) {
    FxBeam = {
		'/mods/HiraganaV12/effects/emitters/ch_bea01_Beam.bp',
        #'/mods/HiraganaV12/effects/emitters/particle_cannon_beam_02_emit.bp'
	},
    FxBeamEndPoint = {
		'/mods/HiraganaV12/effects/emitters/ch_bea01_BeamEndPoint.bp',
		#'/mods/HiraganaV12/effects/emitters/particle_cannon_end_02_emit.bp',
	},
    FxBeamEndPointScale = 1,
}

ch_bea01_Weapon = Class(DefaultBeamWeapon) {
    BeamType = ch_bea01_Beam,
	
    FxMuzzleFlash = {'/mods/HiraganaV12/effects/emitters/ch_bea01_Muzzle.bp'},
}

ch_bea01 = Class(TStructureUnit) {
    Weapons = {
        MainGun = Class(ch_bea01_Weapon) {}
    },
}

TypeClass = ch_bea01