local TStructureUnit = import('/lua/terranunits.lua').TStructureUnit
local ADFDisruptorWeapon = import('/lua/aeonweapons.lua').ADFDisruptorWeapon
local utilities = import('/lua/utilities.lua')

ch_sta03 = Class(TStructureUnit) {
    Weapons = {
        MainGun = Class(ADFDisruptorWeapon)
		{
			PlayFxMuzzleSequence = function(self, muzzle)
				ADFDisruptorWeapon.PlayFxMuzzleSequence(self, muzzle)
				local army = self.unit:GetArmy()
				local unit = self.unit
				local BeamThread = ForkThread(function(self)
					local beam1 = AttachBeamEntityToEntity(unit, 'Emitter01', unit, 'Turret01_Muzzle01', army, '/effects/emitters/build_beam_02_emit.bp')
					local beam6 = AttachBeamEntityToEntity(unit, 'Emitter06', unit, 'Turret01_Muzzle01', army, '/effects/emitters/build_beam_02_emit.bp')
					WaitSeconds(0.4)
					local beam2 = AttachBeamEntityToEntity(unit, 'Emitter02', unit, 'Turret01_Muzzle01', army, '/effects/emitters/build_beam_02_emit.bp')
					local beam5 = AttachBeamEntityToEntity(unit, 'Emitter05', unit, 'Turret01_Muzzle01', army, '/effects/emitters/build_beam_02_emit.bp')
					WaitSeconds(0.4)
					local beam3 = AttachBeamEntityToEntity(unit, 'Emitter03', unit, 'Turret01_Muzzle01', army, '/effects/emitters/build_beam_02_emit.bp')
					local beam4 = AttachBeamEntityToEntity(unit, 'Emitter04', unit, 'Turret01_Muzzle01', army, '/effects/emitters/build_beam_02_emit.bp')
					WaitSeconds(0.8)
					beam1:Destroy()
					beam6:Destroy()
					WaitSeconds(0.4)
					beam2:Destroy()
					beam5:Destroy()
					WaitSeconds(0.4)
					beam3:Destroy()
					beam4:Destroy()
					KillThread(self)
				end)
			end,
		}
    },
	
	OnCreate = function(self)
		TStructureUnit.OnCreate(self)
		CreateAttachedEmitter(self, 'Emitter01', self:GetArmy(), '/effects/emitters/urc1501_ambient_01_emit.bp'):ScaleEmitter(0.5)
		CreateAttachedEmitter(self, 'Emitter02', self:GetArmy(), '/effects/emitters/urc1501_ambient_01_emit.bp'):ScaleEmitter(0.5)
		CreateAttachedEmitter(self, 'Emitter03', self:GetArmy(), '/effects/emitters/urc1501_ambient_01_emit.bp'):ScaleEmitter(0.5)
		CreateAttachedEmitter(self, 'Emitter04', self:GetArmy(), '/effects/emitters/urc1501_ambient_01_emit.bp'):ScaleEmitter(0.5)
		CreateAttachedEmitter(self, 'Emitter05', self:GetArmy(), '/effects/emitters/urc1501_ambient_01_emit.bp'):ScaleEmitter(0.5)
		CreateAttachedEmitter(self, 'Emitter06', self:GetArmy(), '/effects/emitters/urc1501_ambient_01_emit.bp'):ScaleEmitter(0.5)
		
		local unit = self
		local army = self:GetArmy()
		
		local SearchRadiusThread = ForkThread(function(self)
			while (not unit:IsDead()) do
				unit.HasHit = false
				local position = unit:GetPosition()
				local radius = unit:GetWeapon(1):GetBlueprint().MaxRadius
				local x1 = position.x - radius
				local y1 = position.y - radius
				local z1 = position.z - radius
				local x2 = position.x + radius
				local y2 = position.y + radius
				local z2 = position.z + radius
				local UnitsinRec = GetUnitsInRect( Rect(x1, z1, x2, z2) )
				
				local prevHealthPercentage = 100
				local newTarget = nil
				
				if not UnitsinRec then
					return UnitsinRec
				end
			    for k, v in UnitsinRec do
					local dist = VDist3(position, v:GetPosition())
					if (unit != v) and (EntityCategoryContains(categories.STRUCTURE, v)) and (v:GetArmy() != 12) and (not v:IsBeingBuilt()) and (not (v:GetHealth() == v:GetMaxHealth())) and (dist <= radius) then
						if (((v:GetHealth()) / (v:GetMaxHealth())) * 100) < prevHealthPercentage then
							newTarget = v
							prevHealthPercentage = ((v:GetHealth()) / (v:GetMaxHealth())) * 100
						end
					end
				end
				
				if (newTarget != nil) then
					#LOG('Now targeting: ' .. newTarget:GetBlueprint().General.UnitName)
					while (not unit.HasHit) and (not unit:IsDead()) and (not newTarget:IsDead()) and (VDist3(position, newTarget:GetPosition()) <= radius) and (not (newTarget:GetHealth() == newTarget:GetMaxHealth())) do
						unit:GetWeapon(1):SetTargetEntity(newTarget)
						WaitSeconds(0.1)
					end
					WaitSeconds(0.1)
				else
					WaitSeconds(0.15)
				end
			end
			KillThread(self)
		end)
	end,
}

TypeClass = ch_sta03