local TWalkingLandUnit = import('/lua/terranunits.lua').TWalkingLandUnit
local Unit = import('/lua/sim/Unit.lua').Unit
local TDFMachineGunWeapon = import('/lua/terranweapons.lua').TDFMachineGunWeapon


ch_uni01 = Class(TWalkingLandUnit) {
	OnCreate = function(self)
		FaceRadar = Class(TDFMachineGunWeapon) {}
		TWalkingLandUnit.OnCreate(self)
		
		self.Rotator = CreateRotator(self, 0, 'y', nil, 0, 0, 0)
		
		local unit = self
		local army = self:GetArmy()
		local targetCurrent = nil
		
		local SearchRadiusThread = ForkThread(function(self)
			while (not unit:IsDead()) do
				if (targetCurrent == nil) then
					local position = unit:GetPosition()
					local radius = 15
					local x1 = position.x - radius
					local y1 = position.y - radius
					local z1 = position.z - radius
					local x2 = position.x + radius
					local y2 = position.y + radius
					local z2 = position.z + radius
					local UnitsinRec = GetUnitsInRect( Rect(x1, z1, x2, z2) )
					
					local targetNew = nil
					
					if not UnitsinRec then
						return UnitsinRec
					end
				    for k, v in UnitsinRec do
						local dist = VDist3(position, v:GetPosition())
						if (IsEnemy(army, v:GetArmy()))  and (dist <= radius) then
							targetNew = v
							targetCurrent = v
						end
					end
					
					if (targetNew != nil) then
						#LOG('Now targeting: ' .. targetNew:GetBlueprint().General.UnitName)
						#local unitGroup = {}
						#table.insert(unitGroup,unit)
						#local brainArmy = GetArmyBrain(army)
						#local unitPlatoon = brainArmy:MakePlatoon('','')
						#brainArmy:AssignUnitsToPlatoon(unitPlatoon, unitGroup, 'Attack', 'GrowthFormation')
						#IssueClearCommands(unit)
						#IssueAttack(unit, targetNew:GetBlip(targetNew:GetArmy())) 
						IssueAttack({unit},  targetNew)
						#unitPlatoon:Stop()
						#unitPlatoon:AggressiveMoveToLocation(newPosition)
						WaitSeconds(0.1)
					else
						WaitSeconds(0.1)
					end
				elseif (targetCurrent:IsDead()) then
					-- if the current target is now dead, let it search for another target
					#LOG('TARGET is dead, targetCurrent = nil')
					targetCurrent = nil
				else
					-- if the the current target isn't dead yet, see if close enough to attack
					local attackRange = 2
					if VDist3(unit:GetPosition(), targetCurrent:GetPosition()) <= attackRange then
						#LOG(unit:GetBlueprint().General.UnitName .. ' is within range of ' .. targetCurrent:GetBlueprint().General.UnitName)
						-- stop unit movement
						#IssueStop({unit})
						IssueClearCommands({unit})
						-- rotate unit to point at enemy. (stay looking at the unit even if it is moving, not a priority)
						#CreateRotator(unit, bone, axis, [goal], [speed], [accel], [goalspeed])
						#Unit:HasMeleeSpaceAroundTarget()
						#unit:SetCustomName('Lollerskates')
						unit:MeleeWarpAdjacentToTarget(targetCurrent)
						-- Play attack animation
						if not unit.animPunch then
							unit.animPunch = CreateAnimator(unit)
							unit.Trash:Add(unit.animPunch)
						end
						unit.animPunch:PlayAnim(unit:GetBlueprint().Display.AnimationPunch, false)
						unit.animPunch:SetRate(7)
						-- Delay until punch takes effect
						WaitSeconds(0.2)
						-- Play sound
						#self:PlayUnitSound('UpgradeStart')
						-- DoDamage
						targetCurrent.DoTakeDamage(targetCurrent, unit, 10, 0, 'Normal')
						-- Wait until the animation has finished
						WaitFor(unit.animPunch)
						unit.Rotator:ClearGoal()
						unit.Rotator:SetSpeed(0)
						-- If it kills the unit, let it find a new one
						#if (targetCurrent:IsDead()) then
							#LOG('TARGET is dead')
						#	targetCurrent = nil
						#end
					else
						IssueAttack({unit},  targetCurrent)
					end
					WaitSeconds(0.1)
				end
			end
			KillThread(self)
		end)
	end,
}
TypeClass = ch_uni01